src/Article/urls.py
from django.conf import settings
from django.urls import path, re_path
from django.views.static import serve

from Article.views import *

urlpatterns = [
    path('', ArticleListView.as_view(), name='home'),
    path('ekleclass/', ArticleCreateView.as_view(), name='article_add'),
    path('search/', ArticleSearchView.as_view(), name='search'),
    path('detail/<int:pk>', ArticleDetailView.as_view(), name='detail'),

    path('revizyondetail/<int:pk>/', ArticleItemListView.as_view(), name='revizyonlist'),
    path('revizyondetail/<int:pk>/ekle/', ArticileItemCreate.as_view(), name='article_item_add'),
]

if settings.DEBUG:
    urlpatterns.append(re_path(r'^media/(?P<path>.*)$',
                               serve,
                               {'document_root': settings.MEDIA_ROOT, 'show_indexes': True}))

src/SDS/urls.py
from django.contrib import admin
from django.contrib.auth.views import LoginView, LogoutView
from django.urls import path, include

from django.conf import settings
from django.conf.urls.static import static
from django.views.generic import TemplateView

from rest_framework.authtoken import views
from rest_framework import routers

from Article.views import ArticleViewSet, ArticleItemViewSet

router = routers.DefaultRouter()
router.register(r'article', ArticleViewSet, base_name='ArticleViewSet')
router.register(r'revision', ArticleItemViewSet, base_name='ArticleItemViewSet')

urlpatterns = [
    path('api/', include(router.urls)),
    path('admin/', admin.site.urls),
    path('', TemplateView.as_view(template_name="base/anasayfa.html"), name="anasayfa"),
    path('logged_out/', TemplateView.as_view(template_name="registration/logged_out.html"), name="logged_out"),
    path('login/', LoginView.as_view(), name="login"),
    path('logout/', LogoutView.as_view(next_page="logged_out"), name="logout"),
    path('accounts/', include('accounts.urls')),
    path('article/', include('Article.urls')),
    path('api-token-auth/', views.obtain_auth_token),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

src/Article/models.py
from django.conf import settings
from django.db import models
from django.utils import timezone


from SDS.myFuncitons import Kodlar


class MyCodes(models.Model):
    """
    Kodların tutulduğu table
    """
    type = models.CharField(max_length=32, verbose_name='Dokuman Turu')
    code = models.CharField(max_length=16, verbose_name='Kısa Kodu')
    title = models.CharField(max_length=32, verbose_name='Kod Açıklaması')

    def __str__(self):
        return self.title


class Article(models.Model):
    choices = Kodlar(MyCodes, 'DOKUMANTYPE')
    if not choices:
        choices = [(1, 'veri yok')]
    else:
        choices = Kodlar(MyCodes, 'DOKUMANTYPE')
    title = models.CharField(max_length=32, null=False, blank=False, verbose_name='Dosya Adı')
    type = models.IntegerField(null=True, blank=True, choices=choices, verbose_name='Dosta Türü')
    active = models.BooleanField(default=True, verbose_name='Aktif/Pasif')

    def __str__(self):
        return self.title


class Revisions(models.Model):
    article = models.ForeignKey(Article, on_delete=models.CASCADE,
                                verbose_name='Döküman id', related_name='revision_article')
    uploader = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE,
                                 verbose_name='Döküman Ekleyen', related_name='revision_uploader')
    file = models.FileField(upload_to='document/%Y/%m/%d',
                            verbose_name='Dokuman Path')
    file_sha1 = models.CharField(max_length=32, verbose_name='Benzersiz Kimlik Bilgisi')
    comment = models.TextField(default='dırı vırı ', verbose_name='Dosya Açıklama')
    date = models.DateTimeField(auto_now_add=True, verbose_name='Oluşturma Tarihi')

    def __str__(self):
        return self.comment


class Author(models.Model):
    article = models.ManyToManyField(Article, verbose_name='döküman id', related_name="authors")
    auth_name = models.CharField(max_length=32, verbose_name='Tanımı')

    def __str__(self):
        return self.auth_name


# from dateutil.relativedelta import relativedelta
from django.db.models.signals import post_save
from django.dispatch import receiver

from rest_framework.authtoken.models import Token

@receiver(post_save, sender=settings.AUTH_USER_MODEL)
def create_auth_token(sender, instance=None, created=False, **kwargs):
    if created:
        Token.objects.create(user=instance)

src/Article/forms.py
from django import forms

from Article.models import Revisions, Article
from SDS.myFuncitons import generate_md5


class ArticleCreateForm(forms.ModelForm):
    auth_name = forms.CharField(max_length=32)

    class Meta:
        model = Article
        fields = ['title', 'type', 'active', 'auth_name']
        # fields = '__all__'


class ArticleItemCreateForm(forms.ModelForm):
    def __init__(self, *args, **kwargs):
        self.request = kwargs.pop('request')
        self.article_id = kwargs.pop('article_id')
        super(ArticleItemCreateForm, self).__init__(*args, **kwargs)

    def clean(self):
        file = self.cleaned_data.get('file')
        md5 = generate_md5(file)
        if Revisions.objects.filter(file_sha1=md5).exists():
            raise forms.ValidationError('Eklemeye Çalıştığınız dosya istemde mevcut')
        # TODO: sistemde bulunan dosya bilgisi verilecek
        if not file:
            raise forms.ValidationError('Lütfen dosya ekini ekleyiniz.')

    def save(self, commit=True):
        model = self.Meta.model
        create = model.objects.create(
            article_id=self.article_id,
            file=self.cleaned_data["file"],
            comment=self.cleaned_data["comment"],
            uploader=self.request.user,
            file_sha1=generate_md5(file=self.cleaned_data["file"].open())
        )
        return create

    class Meta:
        model = Revisions
        fields = ['file','comment']
        labels = dict(file=('Dosya'), comment=('Açıklama'))

src/Article/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy
from django.views.generic import ListView, CreateView, DetailView
from django.db.models import Q
from rest_framework.viewsets import ModelViewSet

from Article.forms import ArticleCreateForm, ArticleItemCreateForm
from Article.models import Article, Revisions
from Article.serializers import ArticleSerializer, RrevisionSerializer

class ArticleListView(LoginRequiredMixin, ListView):
    model = Article
    paginate_by = 100
    template_name = "article/article_list.html"

    def get_queryset(self):
        queryset=self.model.objects.filter(active=True)
        return queryset



class ArticleCreateView(LoginRequiredMixin, CreateView):
    template_name = "article/image_form.html"
    form_class = ArticleCreateForm
    success_url = reverse_lazy('anasayfa')



class ArticleViewSet(ModelViewSet):
    serializer_class = ArticleSerializer


    def get_object(self, queryset= None):
        return super(ArticleViewSet, self).get_object()

    def get_queryset(self):
        return Article.objects.filter(active=True)

    def performe_create(self, serializer):
        serializer.save()


class ArticleItemListView(LoginRequiredMixin, ListView):
    model = Revisions
    template_name = 'article/revision_list.html'

    def get_context_data(self, **kwargs):
        context = super(ArticleItemListView, self).get_context_data(**kwargs)
        context.update({
            'Revision_list': Revisions.objects.filter(article_id=self.kwargs['pk']),})
        context['article_id']=self.kwargs['pk']
        return context



class ArticileItemCreate(LoginRequiredMixin, CreateView):
    template_name = "article/image_form.html"
    form_class = ArticleItemCreateForm
    success_url = reverse_lazy('anasayfa')

    def get_form_kwargs(self):
        context = super(ArticileItemCreate, self).get_form_kwargs()
        context['request'] = self.request
        context['article_id'] = self.kwargs["pk"]
        # print(context)
        return context

class ArticleItemViewSet(ModelViewSet):
    serializer_class = RrevisionSerializer


    def get_object(self, queryset= None):
        return super(ArticleItemViewSet, self).get_object()

    def get_queryset(self):
        return Revisions.objects.all()

    def performe_create(self, serializer):
        serializer.save()


class ArticleDetailView(LoginRequiredMixin, DetailView):
    model = Revisions
    template_name = "article/detail.html"



class ArticleSearchView(ListView):
    model = Revisions
    template_name = 'article/searchresults.html'

    def get_queryset(self):
        query = self.request.GET.get('q')
        search_result = Revisions.objects.filter(
            Q(article__title__icontains=query)
            | Q(article__authors__auth_name__icontains=query)
            | Q(comment__icontains=query)

        )
        return search_result

src/Article/templates/article/article_list.html
{% extends "base/base.html" %}

{% load bootstrap4 %}


{% block content %}
    <div class="container">
        <p>Belge Listesi- A-L</p>
        <div class="align-left">

            <table class="table fa-border">
                <tr>
                    <th>Sıra No</th>
                    <th>Adı</th>
                    <th>Aktif</th>
                    <th>Detay</th>
                </tr>

                {% for i in object_list %}

                        <tr>
                            <td>{{ i.id }}</td>
                            <td>{{ i.title }}</td>
                            <td>{{ i.active }}</td>
                            <td><a class="btn btn-secondary btn-sm" href="{% url "revizyonlist" i.id %}">Detay</a></td>
                        </tr>
{#                        <td><a class="btn btn-secondary btn-sm" href="{% url "revizyonlist" i.id %}">Detay</a></td>#}

  {% endfor %}
            </table>
        </div>
    </div>
{% endblock %}

src/Article/templates/article/detail.html
{% extends "base/base.html" %}
{% load bootstrap4 %}
{#    <title>{{ dokuman.detay }}</title>#}
    <title>Döküman Detay</title>
{% block content %}
    <h3>Detay Bilgi</h3>
    <hr>
    <p>ID - {{ object.id}}</p>
    <p>Belge Adı - {{ object.article }}</p>
    <p>Açıklama - {{ object.comment }}</p>
    <p>Ekleyen  - {{ object.uploader }}</p>
    <p>Ekleme Tarihi - {{ object.date }}</p>
    <p>Dosya Bilgisi - {{ object.file }}</p>
    <p>Benzersiz No - {{ object.file_sha1 }}</p>
{#    <p><iframe class="card-img-bottom" src="{{ object.file.url }}"></iframe></p>#}

    <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModal">
  Döküman
</button>

    <hr>


    <!-- Button trigger modal -->
<style>
.resp-container {
    position: relative;
    overflow: hidden;
    padding-top: 56.25%;
}
</style>

<!-- Modal -->
<div style="height: 100%; width: 100%" class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalLabel" style="text-align: center;">{{ revisions.article }}</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <iframe style="width: 465px; height: 640px;" class="resp-iframe" src="{{ object.file.url }}"></iframe>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
      </div>
    </div>
  </div>
</div>



{% endblock %}

src/Article/templates/article/home.html
{% extends "base/base.html" %}
{% load bootstrap4 %}

{##}
{#{% block content %}#}
{##}
{#    <div class="container" align="center">#}
{#        <h1>Belge Listesi</h1>#}
{#        {% for i in qm %}#}
{#            <div align="left">#}
{#              <p>{{ i.label }} - {{ i.type }} - {{ i.comment }} - {{ i.active }}</p>#}
{#            </div>#}
{#        {% endfor %}#}
{#    </div>#}
{#{% endblock %}#}

{% block content %}

    {% for i in object_list %}

        {{ i.label }} - {{ i.type }} - {{ i.comment }} - {{ i.active }}

    {% endfor %}



{% endblock %}

src/Article/templates/article/image_form.html
{% extends "base/base.html" %}
{% load static %}
{% load staticfiles %}
{% load crispy_forms_tags %}
{% load bootstrap4 %}

{% block content %}

    <div class="card mx-auto shadow p-3 mb-5 bg-white rounded text-left" style="max-width: 50rem;">
        <div class="container">
            <form action="" method="post" enctype="multipart/form-data">
                {% csrf_token %}
                {#           {% bootstrap_form form %}#}
                {{ form|crispy }}
                <input type="submit" value="Gonder gitsin" class="btn btn-outlined-primary">
            </form>

            {% if form.errors %}
                {% for field in form %}
                    {% for error in field.errors %}
                        <p> {{ error }} </p>
                    {% endfor %}
                {% endfor %}
            {% endif %}

        </div>
    </div>

{% endblock content %}

src/Article/templates/article/revision_list.html
{% extends "base/base.html" %}

{% load bootstrap4 %}


{% block content %}
    <div class="container">
    <p>revision_list</p>
    <div class="align-left">



{#{% if Revision_list.values_list.1.1 %}#}
{#<a class="btn btn-success btn-sm actions" href="{% url 'article_item_add' pk=Revision_list.values_list.1.1  %}">Ekle</a><br><br>#}
{#    {% else %}#}
    <a class="btn btn-success btn-sm actions" href="{% url 'article_item_add' pk=article_id %}">Ekle</a><br><br>
{#{% endif %}#}


    <table class="table fa-border">
        <tr>
            <th>Sıra No </th>
            <th>Adı</th>
            <th>Type</th>
            <th>Tarih</th>
            <th>Açıklama</th>
            <th>Benzersiz No</th>
            <th>Detay Bilgisi</th>
{#            <th>Revizyon Ekle</th>#}
        </tr>
        {% for i in Revision_list %}

        <tr>
            <td>{{ i.id }}</td>
            <td>{{ i.article }}</td>
            <td>{{ i.article.type }}</td>
            <td>{{ i.date }}</td>
            <td>{{ i.comment }}</td>
            <td>{{ i.file_sha1 }}</td>
            <td><a class="btn btn-secondary btn-sm" href="{% url "detail" i.id%}">Detay</a></td>
        </tr>
                {% endfor %}
    </table>
</div>
    </div>
{% endblock %}

src/Article/templates/article/rlist.html
{% extends "base.html" %}
{% load bootstrap3 %}
{% load querystring from django_tables2 %}
{% load title from django_tables2 %}
{% load trans blocktrans from i18n %}

{% block content %}


{% if table.page %}
  <div class="table-container">
{% endif %}

{% block table %}
    <div class="table-responsive">
        <table class="table table-hover table-bordered table-striped"{% if table.attrs %} {{ table.attrs.as_html }}{% endif %}>
            {% block table.thead %}
            <thead>
                <tr>
                    <th><a href="{% url "customer-add" %}" class="btn btn-small btn-primary dark"><span class="hidden-phone"><i class="fa fa-user-plus"></i> Add Customer</span></a>

                    </th>
                    <th colspan="5">
                        <form method="post" class="form-inline form-search pull-right">
                          {% csrf_token %}
                            <div>
                              <input id="search_form_id" name="search" type="text" class="form-control col-md-3" placeholder="ID, Name, Account #, ZIP"{% if search %} value="{{ search }}"{% endif %}>
                              <button type="submit" class="btn btn-small btn-dark"><i class="fa fa-search"></i> Search</button>
                            </div>
                        </form>
                    </th>
                </tr>

              <tr>
                {% for column in table.columns %}
                    {% if column.orderable %}
                    <th {{ column.attrs.th.as_html }}><a href="{% querystring table.prefixed_order_by_field=column.order_by_alias.next %}">{{ column.header|title }}</a></th>
                    {% else %}
                    <th {{ column.attrs.th.as_html }}>{{ column.header|title }}</th>
                    {% endif %}
                {% endfor %}
              </tr>
            </thead>
            {% endblock table.thead %}
            {% block table.tbody %}
            <tbody>
                {% for row in table.page.object_list|default:table.rows %} {# support pagination #}
                  {% block table.tbody.row %}
                  <tr class="{% cycle "odd" "even" %}">
                      {% for column, cell in row.items %}
                          <td {{ column.attrs.td.as_html }}>{{ cell }}</td>
                      {% endfor %}
                  </tr>
                  {% endblock table.tbody.row %}
                {% empty %}
                  {% if table.empty_text %}
                  {% block table.tbody.empty_text %}
                  <tr><td colspan="{{ table.columns|length }}">{{ table.empty_text }}</td></tr>
                  {% endblock table.tbody.empty_text %}
                  {% endif %}
                {% endfor %}
            </tbody>
            {% endblock table.tbody %}
            {% block table.tfoot %}
            <tfoot></tfoot>
            {% endblock table.tfoot %}
        </table>
    </div>
{% endblock table %}

{% if table.page %}
    {% block pagination %}
        {% bootstrap_pagination table.page url=request.get_full_path %}
    {% endblock pagination %}
  </div>
{% endif %}


{% endblock content %}

src/Article/templates/article/searchresults.html
{% extends "base/base.html" %}

{% load bootstrap4 %}


{% block content %}
    <div class="container">
    <p>revision_list</p>
    <div class="align-left">


    <table class="table fa-border">
        <tr>
            <th>Sıra No </th>
            <th>Adı</th>
            <th>Tarih</th>
            <th>Açıklama</th>
            <th>Benzersiz No</th>
            <th>Detay Bilgisi</th>
        </tr>
        {% for i in revisions_list %}

        <tr>
            <td>{{ i.pk }} -</td>
            <td>{{ i.article}}</td>
            <td>{{ i.file }}</td>
            <td>{{ i.comment}}</td>
            <td>{{ i.file_sha1 }}</td>
            <td><a class="btn btn-secondary btn-sm" href="{% url "detail" pk=i.id%}">Detay Bilgisi</a></td>

        </tr>
                {% endfor %}
    </table>
</div>
    </div>
{% endblock %}